﻿<AML>
 <Item type="Method" id="C41E7256DB6E487C9D82064E1ECFF8BB" action="add">
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[/* *****************************************************************************
Method Name:			acc_set_home_currency
Created By		:		SolidCAD 
Creation Date:			2018-01-23
Description:
    -Get Currency,Rate,Operator of Default Currency and set to pop_currency,pop_currency_rate and pop_currency_operator.
    -Get last month rate,operator for SGD and set to pop_sg_currency_rate and pop_sg_operator.
	
Hooks:
	
	Type:	Form	:	sop_commercial_invoice
	Event:	Form Event ( onLoad )
	
	Type:	Form	:	sop_po_out
	Event:	Form Event ( onLoad )
	
	Type:	Form	:	sop_sale_invoice
	Event:	Form Event ( onLoad )
	
	Type:	Form	:	sop_sale_order
	Event:	Form Event ( onLoad )
	
	Type:	Form	:	sop_sale_order_Equipment
	Event:	Form Event ( onLoad )
	
	Type:	Form	:	sop_sale_order_Service
	Event:	Form Event ( onLoad )

Revisions:
	Rev Date		Modified By			Description
	YYYY-MM-DD		$username$			Initial creation
***************************************************************************** */

//debugger;
var myInnovator = new Innovator();
var itemType = document.thisItem.getType().toString().toLowerCase();
var date_for_SG = "";
switch (itemType) {
    case 'sop_po_out':
        {
            var pop_po_date = document.thisItem.getProperty('pop_po_date');
            if (!pop_po_date) {
                date_for_SG = dateFormat(todayDate);
            } else {
                date_for_SG = pop_po_date;
            }

        }
        break;
    case 'sop_sale_order':
        {
            var sop_order_date = document.thisItem.getProperty('sop_order_date');
            if (!sop_order_date) {
                date_for_SG = dateFormat(todayDate);

            } else {
                date_for_SG = sop_order_date;
            }
        }
        break;

    case 'sop_sale_invoice':
        {
            var sop_invoice_date = document.thisItem.getProperty('sop_invoice_date');
            if (!sop_invoice_date) {
                date_for_SG = dateFormat(todayDate);

            } else {
                date_for_SG = sop_invoice_date;
            }
        }
        break;

    case 'sop_commercial_invoice':
        {
            var sop_invoice_date = document.thisItem.getProperty('sop_invoice_date');
            if (!sop_invoice_date) {
                date_for_SG = dateFormat(todayDate);

            } else {
                date_for_SG = sop_invoice_date;
            }
        }
        break;
}
var default_curr_qry = myInnovator.newItem("acc_currency", "get");
default_curr_qry.setProperty("acc_isdefault", 1);
var default_curr_qry_result = default_curr_qry.apply();
var l_curr_count = default_curr_qry_result.getItemCount();
if (l_curr_count > 0) {
    var default_currency = default_curr_qry_result.getItemByIndex(0);
    var default_currency_code = default_currency.getProperty("acc_currencycode", "");
    var pop_currency = document.thisItem.getProperty('pop_currency');
    if (!pop_currency) {
        myHandleItemChange("pop_currency", default_currency.getProperty("id", ""));
        myHandleItemChange("pop_currency_rate", "1");
        myHandleItemChange("pop_currency_operator", "*");
    }

}

//get SG rate

var currency_result = myInnovator.applyMethod("acc_SG_currency_info", "<currency_date>" + date_for_SG + "</currency_date>");

var currency_count = currency_result.getItemCount();
if (currency_count > 0) {
    if (pop_currency != currency_result.getProperty("id", "")) {
        var sg_rate = currency_result.getProperty("acc_monthly_rate", "");
        var sg_operator = currency_result.getProperty("acc_operator", "");
        myHandleItemChange("pop_sg_currency_rate", sg_rate);
        myHandleItemChange("pop_sg_operator", sg_operator);
    }
}

function myHandleItemChange(property, value) {
    if (top.instance.document) {
        
        top.instance.handleItemChange(property, value);
    } else {
        
        top.frames[1].handleItemChange(property, value);
    }
}

function dateFormat(d) {
    var dateString = d.getFullYear() + "-";
    dateString += pad(d.getMonth() + 1) + "-";
    dateString += pad(d.getDate()) + "T";
    dateString += pad(d.getHours()) + ":";
    dateString += pad(d.getMinutes()) + ":";
    dateString += pad(d.getSeconds());
    return dateString;
}

function pad(x) {
    return (x < 10) ? "0" + x : "" + x;
}]]></method_code>
  <method_type>JavaScript</method_type>
  <name>acc_set_home_currency</name>
 </Item>
</AML>